;********** FREEWAY FROG **********
;
;
;
;
;   Página 191
            ORG     27000
START       DI                      ; DISABLE BASIC SYSTEM AFFECTING
            EXX                     ; THE KEYBOARD SCANNING
            PUSH    HL              ; PRESERVE THE HL' REGISTER PAIR
            EXX                     ; POP BACK BEFORE RETURN
AGAIN       CALL    INIT            ; INITIALISATION
MOVE        CALL    TFCTRL          ; TRAFFIC CONTROL ROUTINE
            CALL    RESPC           ; RESTORE UNDERNEATH
            CALL    MOVTRF          ; MOVE TRAFFIC
            CALL    POLICE          ; POLICE CAR ROUTINE
            CALL    FROG            ; FROG MODULE
            CALL    CALSCR          ; CALCULATE AND DISPLAY SCORE
            CALL    SIREN           ; SIREN R DELAY
            LD      A,(GAMFLG)      ; FINISH WHEN NO FROG
            AND     A
            JR      NZ,CONTIN
            CALL    OVER            ; HIGHSCORE MANAGEMENT
            JR      AGAIN           ; NEW GAME AGAIN
CONTIN      LD      A,$7F           ; TRAP SPACE KEY PRESSED
            IN      A,($FE)         ; SCAN KEYBOARD
            AND     1               ; TEST KEY SPACE
            JR      NZ,MOVE
            CALL    FINAL           ; RESET SCREEN AND BORDER COLOUR
            EXX
            POP     HL              ; RETRIEVE HL'
            EXX
            EI                      ; ENABLE INTERRUPTS
            RET                     ; RETURN TO BASIC SYSTEMS
;
;
; ********** FROGDB/ASM **********
;
FRGSHP      DEFW    FROG1           ; UP FROG
            DEFW    FROG2           ; RIGHT FROG
            DEFW    FROG3           ; DOWN FROG
            DEFW    FROG4           ; LEFT FROG
FROG1       DB      111,15,31,159,220,216,120,48
            DB      246,240,248,249,59,27,30,12
            DB      0,1,35,37,111,79,223,255
            DB      0,128,196,164,246,242,251,255
FROG2       DB      31,31,31,127,252,193,113,56
            DB      254,244,248,240,192,156,240,192
            DB      56,113,193,252,127,31,31,31
;   Página 192
            DB      192,240,156,192,240,248,244,254
FROG3       DB      255,223,79,111,37,35,1,0
            DB      255,251,242,246,164,196,128,0
            DB      48,120,216,220,159,31,15,111
            DB      12,30,27,59,249,248,240,246
FROG4       DB      127,47,31,15,3,57,15,3
            DB      240,240,248,254,63,131,142,28
            DB      3,15,57,3,15,31,47,127
            DB      28,142,131,63,254,248,240,240
;
;
LBIKE       DB      0,0,0,0,0,0,0,0
            DB      31,63,115,81,169,112,112,32
            DB      254,252,252,234,213,206,14,4
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      1,3,1,0,3,4,14,31
            DB      128,192,192,224,224,112,119,255
            DB      0,0,0,0,0,0,0,0
;
LBATT       DB      0,7,7,0
            DB      0,7,7,0
;
RBIKE       DB      0,0,0,0,0,0,0,0
            DB      127,63,63,87,171,115,112,32
            DB      248,252,206,138,149,14,14,4
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      1,3,3,7,7,14,238,255
            DB      128,192,128,0,192,32,112,248
;   Página 193            
            DB      0,0,0,0,0,0,0,0
;
;
RBATT       DB      0,7,7,0
            DB      0,7,7,0
;
;
LCAR        DB      0,0,0,0,0,0,0,0
            DB      0,0,3,7,15,2,0,0
            DB      7,255,255,159,111,247,240,96
            DB      128,255,255,255,255,254,0,0
            DB      240,254,255,159,111,246,240,96
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,63,97,193
            DB      0,0,0,0,0,0,128,192
            DB      0,0,0,0,0,0,0,0
;
LCATT       DB      0,6,6,6,6,0
            DB      0,0,0,6,6,0
;
;
RCAR        DB      0,0,0,0,0,0,0,0
            DB      15,127,255,249,246,111,15,6
            DB      1,255,255,255,255,127,0,0
            DB      224,255,255,249,246,239,15,6
            DB      0,0,192,224,240,64,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
;   Página 194            
            DB      0,0,0,0,0,0,1,3
            DB      0,0,0,0,0,252,134,131
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
;
;
RCATT       DB      0,2,2,2,2,0
            DB      0,2,2,0,0,0
;
;
LTRUCK      DB      0,0,0,0,0,0,0,0
            DB      31,31,31,62,61,59,3,1
            DB      248,252,254,127,184,216,192,128
            DB      255,255,255,255,6,15,15,6
            DB      255,255,255,0,0,0,0,0
            DB      255,255,255,0,0,0,0,0
            DB      255,255,255,0,6,15,15,6
            DB      254,254,254,4,50,122,122,48
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,7,9,17,17,31,31
            DB      2,2,250,250,254,252,252,248
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      254,254,254,254,254,254,254,254
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
;   Página 195            
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,254,254,254
            DB      0,0,0,0,0,0,0,0
;
;
LTATT       DB      0,3,3,5,5,5,5,5,0
            DB      0,3,3,5,5,5,5,5,0
            DB      0,0,0,5,5,5,5,5,0
;
;
RTRUCK      DB      0,0,0,0,0,0,0,0
            DB      127,127,127,32,76,94,94,12
            DB      255,255,255,0,96,240,240,96
            DB      255,255,255,0,0,0,0,0
            DB      255,255,255,0,0,0,0,0
            DB      255,255,255,255,96,240,240,96
            DB      31,63,127,254,29,27,3,1
            DB      248,248,248,124,188,220,192,128
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      127,127,127,127,127,127,127,127
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      255,255,255,255,255,255,255,255
            DB      64,64,95,95,127,63,63,31
;   Página 196            
            DB      0,0,224,144,136,136,248,248
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,127,127,127
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,255,255,255
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
            DB      0,0,0,0,0,0,0,0
;
;
RTATT       DB      0,5,5,5,5,5,3,3,0
            DB      0,5,5,5,5,5,3,3,0
            DB      0,5,5,5,5,5,0,0,0
;
;
BLANK       DB      0,0,0,0
;
;
FRGSTR      DEFS    36              ; 4*8+4
PCSTR       DEFS    120             ; 12*8+12+7
;
;
; ********** DATA BASE **********
OB1EXT      DEFB    0               ; OBJECT 1 EXISTENCE
            DEFB    0               ; CYCLE COUNT
            DEFB    0               ; DIRECTION, 0=>RIGHT
            DEFB    0               ; OBJECT 1 POS REAL/ABS
            DEFW    0               ; POSITION COUNTER
            DEFW    0               ; SHAPE POINTER
            DEFW    0               ; ATTRIBUTE POINTER
            DEFB    0               ; ROW COUNTER
            DEFB    0               ; COLUMN POINTER
OB2EXT      DB      0,0,0,0
            DEFW    0               ; OBS2 POS REAL/ABS FLAG
            DEFW    0
;   Página 197            
            DEFW    0
            DB      0,0
OB3EXT      DB      0,0,0,0
            DEFW    0
            DEFW    0
            DEFW    0
            DB      0,0
OB4EXT      DB      0,0,0,0
            DEFW    0
            DEFW    0
            DEFW    0
            DB      0,0
OB5EXT      DB      0,0,0,0
            DEFW    0
            DEFW    0
            DEFW    0
            DB      0,0
OB6EXT      DB      0,0,0,0
            DEFW    0
            DEFW    0
            DEFW    0
            DB      0,0
;
;
PCAREXT     DEFB    0               ; POLICE CAR DATABASE
PCARCYC     DEFB    0
PCARDIR     DEFB    0
PCARRAP     DEFB    0
PCARPOS     DEFW    0
PCARSHP     DEFW    0
PCARATT     DEFW    0
PCARROW     DEFB    2
PCARCOL     DEFB    6
;
;
FRGEXT      DEFB    0               ; FROG DATABASE
FRGCYC      DEFB    0
FRGDIR      DEFB    0
FRGPOS      DEFW    0
FROGSH      DEFW    0
FRGATR      DEFB    0
;
;
FRGDB       DB      8,8,1
FRGSTN      DEFW    $50AC           ; INITIAL POSITION OF FROG
            DEFW    FROG1
;   Página 198            
            DB      4               ; ATTR. TOTAL 8 CHARS
DBINDEX     DEFW    RBDB            ; RIGHT BYKE DB
            DEFW    LBDB            ; LEFT BYKE DB
            DEFW    RCDB            ; RIGHT CAR DB
            DEFW    LCDB            ; LEFT CAR DB
            DEFW    RTDB            ; RIGHT TRUCK DB
            DEFW    LTDB            ; LEFT TRUCK DB
;
;
RBDB        DB      2,1,0,0         ; EXT CNT DIR RAF
            DEFW    $481D           ; POS
            DEFW    RBIKE           ; RIGHT BIKE
            DEFW    RBATT           ; ATTRIBUTE
            DB      2,4             ; ROW COL
;
;
LBDB        DB      2,1,1,1
            DEFW    $48DF
            DEFW    LBIKE
            DEFW    LBATT
            DB      2,4
;
;
RCDB        DB      3,1,0,0
            DEFW    $481B
            DEFW    RCAR
            DEFW    RCATT
            DB      2,6
;
;
LCDB        DB      3,1,1,1
            DEFW    $48DF
            DEFW    LCAR
            DEFW    LCATT
            DB      2,6
;
;
RTDB        DB      6,1,0,0
            DEFW    $4818
            DEFW    RTRUCK
            DEFW    RTATT
            DB      3,9
;
;
;   Página 199
LTDB        DB      6,1,1,1
            DEFW    $48DF
            DEFW    LTRUCK
            DEFW    LTATT
            DB      3,9
;
;
LPCDB       DB      1,1,1,1
            DEFW    $48DF
            DEFW    LCAR
            DEFW    LPCATT
            DB      2,6
;
;
LPCATT      DB      0,5,5,5,5,0
            DB      0,0,0,5,5,0
;
;
RPCDB       DB      1,1,0,0
            DEFW    $481B
            DEFW    RCAR
            DEFW    RPCATT
            DB      2,6
;
;
RPCATT      DB      0,5,5,5,5,0
            DB      0,5,5,0,0,0
;
;
;
;
PCTON1      DB      41,0,$F0,1      ; FIRST POLICE CAR TONE
PCTON2      DB      23,0,$8C,3      ; SECOND POLICE CAR TONE
;
;
HOMTON      DB      $46,0,$C7,4     ; FROG REACH HOME TONE
            DB      $5D,0,$8C,3
            DB      $7C,0,$A1,2
            DB      $AA,0,$F1,1
            DB      $DE,0,$6D,1
;   Página 200
            DB      $28,1,9,1
            DB      $8B,1,$BF,0
            DB      $0F,2,$88,0
            DB      $C0,2,$5E,0
DIETON      DB      $84,3,$43,0     ; FROG DYING TONE, REVERSE
;
;
SCRMS1      DEFM   'Score '
SCORE       DB      $30,$30,$30,$30,$30,$30
SCRMS2      DEFM   'HIGH SCORE '
HISCR       DB      $30,$30,$30,$30,$30
;
;
IMAGE       DEFS    5               ; PRINTING IMAGE OF SCORE
UPDWN       DEFB    0               ; SET WHEN FROG MOVES UP OR DOWN
;
;
COLUMN      DB      0               ; VARIABLE STORING SHAPE COLUMN
ROW         DB      0               ; VARIABLE STORING SHAPE ROW
SKIP        DEFB    0               ; CHAR SKIPPING DURING DRAW
FILL        DEFB    0               ; CHAR DRAWN
ATTPOS      DEFW    0               ; HOLDING THE ATTRIBUTE FILE PTR
ATTR        DB      0               ; ATTR OF CHARACTER BLOCK DRAWN
DRWPOS      DEFW    0               ; DRAW POSITION
STRPOS      DEFW    0               ; STORE POSITION
;
;
ATTPTR      DEFW    0
NEWPOS      DEFW    0               ; NEW TRAFFIC OBJECT POSITION
POSPTR      DEFW    0               ; TRAFFIC POSITION DATABASE PTR
GENFLG      DEFB    0               ; TRAFFIC REGENERATION FLAG
;
;
JAMFLG      DEFB    0               ; SET TO 1 AS TRAFFIC MOVE JAM
;
;
CHASE       DEFB    0               ; SET WHEN POLICE CAR APPEARS
SOUNDF      DEFB    0               ; SET WHEN USER WANT SIREN SOUND
TONFLG      DEFB    0               ; DETERMINE WHICH SIEN TONE
RND         DEFW    0               ; POINTER TO ROM FOR RANDOM NO
;
;
GAMFLG      DEFB    1               ; END IF ZERO
OLDFRG      DEFW    0               ; OLD FROG POS
NEWFRG      DEFW    0               ; NEW FROG POS
;   Página 201
CRHFLG      DEFB    0               ; SET TO 1 WHEN FROG WAS CRASH
TEMDIR      DEFB    0               ; FROG TEMPORARY NEW DIRECTION
TEMPOS      DEFW    0               ; FROG TEMPORARY NEW POSITION
TEMSHP      DEFW    0               ; FROG TEMPORARY NEW SHAPE
;
;
BOTHY1      EQU     $5020           ; 0,38. 0,39
BOTHY2      EQU     $5120
TOPHY1      EQU     $46A0           ; 0,128. 0,129
TOPHY2      EQU     $47A0
MIDHY1      EQU     $4B60           ; x,83. x,84
MIDHY2      EQU     $4C60
;
;
CHRSET      EQU     $3C00           ; FIRST 256 BYTES NOTHING
;
;
NUMFRG      DEFB    5               ; NUMBER OF FROG
;
;
; ********** INIT **********
;
INIT        XOR     A               ; 000 FOR D2 D1 D0
            OUT     ($FE), A        ; SET BORDER COLOUR
            LD      (23624), A      ; TO BLACK
            LD      (CRHFLG),A
            LD      (FRGEXT),A      ; SET FROG NO EXIST
            INC     A
            LD      (GAMFLG),A      ; SET GAME FLAG
            LD      A,5             ; INITIALISE FROG NO
            LD      (NUMFRG),A
            LD      A,R             ; GENERATE RANDOM PTR
            AND     $3F             ; FOR THIS CYCLE
            LD      H,A             ; PTR POINTS TO ROM
            LD      A,R
            LD      L,A
            LD      (RND),HL
            LD      HL,$50AC        ; INIT FROG STATION
            LD      (FRGSTN),HL
            CALL    CLRSCR          ; CLEAR SCREEN ROUTINE
            CALL    DRWHWY          ; DRAW HIGHWAY
            CALL    LINEUP          ; LINE UP ALL EXIST FROGS
            LD      HL,$4000        ; MESSAGE LOCATION
            LD      DE,SCRMS1       ; LOAD SCORE MESSAGE
            LD      B,6
            CALL    DISASC          ; DISPLAY ASCII CHARACTER
            LD      HL,SCORE+1      ; PRINT SCORE
            CALL    SCRIMG          ; CONVERT TO PRINTABLE IMAGE
            LD      HL,$4006
            LD      DE,IMAGE
            LD      B,5
            CALL    DISASC
            LD      HL,$400E        ; HIGH SCORE MESSAGE
            LD      DE,SCRMS2
            LD      B,11
            CALL    DISASC
            LD      HL,HISCR
            CALL    SCRIMG
;   Página 202
            LD      HL,$4019
            LD      DE,IMAGE
            LD      B,5
            CALL    DISASC
            LD      HL,OB1EXT       ; SET ALL OBJ NONEXIST
            LD      DE,12
            LD      B,7
            XOR     A
INTPL1      LD      (HL),A
            ADD     HL,DE
            DJNZ    INTPL1
            LD      (CHASE),A       ; SET NO POCIE CAR CHASE
            INC     A
            LD      (SOUNDF),A      ; SET SIREN ON
            LD      HL,SCORE        ; INITIALISE SCORE TO
            LD      DE,SCORE+1      ; ASCII CERO ie $30
            LD      C,5
            LD      (HL),$30
            LDIR                    ; INIT SCORE TO $30
            RET
;
;
; ********** DRWHWY **********
;
DRWHWY      LD      HL,$40A0        ; FILL TOP HWY
            CALL    FILHWY
            LD      HL,$4860        ; FILL MIDDLE HWY
            CALL    FILHWY
            LD      HL,$5020        ; FILL BOTTOM HWY
            CALL    FILHWY
            LD      HL,TOPHY1       ; REVERSE BUILT HIGHWAY
            LD      DE,TOPHY2
            XOR     A
            CALL    HIGHWY
            LD      HL,BOTHY1
            LD      DE,BOTHY2
            CALL    HIGHWY
            LD      HL,MIDHY1
            LD      DE,MIDHY2
            LD      A,195           ; BIN 11000011
HIGHWY      LD      B,32            ; 32*8 BITS
HWYLOP      LD      (HL),A
            LD      (DE),A
            INC     HL
            INC     DE
            DJNZ    HWYLOP
            RET
;
;
; ********** FILHWY **********
;
FILHWY      LD      A,$FF
            EXX
            LD      B,32
FILHYL      EXX
            PUSH    HL
            LD      B,8
FILCHR      LD      (HL),A
            INC     H
            DJNZ    FILCHR
;   Página 203
            POP     HL
            INC     HL
            EXX
            DJNZ    FILHYL
            EXX
            RET
;
;
; ********** LINEUP **********
;
;           draw all frogs on the screen
;
;
LINEUP      LD      A,1             ; RIGHT FROG
            LD      (FRGDIR),A
            LD      DE,FROG2        ; RIGHT FROG SHAPE
            LD      HL,(FRGSTN)     ; FROG STATION
            LD      A,4             ; (PAPER 0)*8+(INK 4)
            LD      (ATTR),A
            LD      A,(NUMFRG)      ; NUMBER OR FROG
            AND     A               ; TEST FOR NO FROG LEFT
            RET     Z
            LD      B,A             ; NUMBER OF FROG TIMES
DRAWLN      PUSH    BC
            PUSH    DE
            PUSH    HL
            CALL    DRWFRG          ; DRAW FROG RUTINE
            POP     HL
            POP     DE
            DEC     HL
            DEC     HL
            DEC     HL
            POP     BC
            DJNZ    DRAWLN
            RET
;
;
; ********** DRWFRG **********
;           similar to DRAW routine
;
DRWFRG      LD      A,2             ; TWO ROW FROG SHAPE
            EX      AF,AF'
            PUSH    HL              ; STORE POS PTR
FRGLP0      PUSH    HL
            LD      C,2             ; COLUMN COUNT
FRGLP1      PUSH    HL
            LD      B,8             ; DRAW CHARACTER
FRGLP2      LD      A,(DE)
            LD      (HL),A
            INC     DE
            INC     H               ; NEXT BYTE OF THE CHAR
            DJNZ    FRGLP2
            POP     HL              ; CURRENT POINTER
            INC     HL              ; MOVE TO NEXT CHAR POS
            DEC     C               ; DECR COLUMN COUNT
;   Página 204
            JR      NZ,FRGLP1
            POP     HL              ; ROW PTR
            EX      AF,AF'
            DEC     A               ; DEC LINES OF CHAR
            LD      C,32
            JR      Z,FRGATT        ; LOAD FROG ATTRIBUTE
            EX      AF,AF'
            AND     A
            SBC     HL,BC           ; MOVE 32 CHAR/1 LINE UP
            BIT     0,H             ; TEST CROSS SCR SECTION
            JR      Z,FRGLP0
            LD      A,H
            SUB     7               ; UP ONE SCREEN SETION
            LD      H,A
            JR      FRGLP0
FRGATT      POP     HL              ; POS STR
            LD      A,H             ; CONVERT TO ATTRIBUTE PTR
            AND     $18
            SRA     A
            SRA     A
            SRA     A
            ADD     A,$58
            LD      H,A
            LD      A,(ATTR)        ; FILL FROG SHAPE ATTR
            LD      (HL),A
            INC     HL              ; NEXT CHARACTER
            LD      (HL),A
            SBC     HL,BC           ; ONE LINE UP
            LD      (HL),A
            DEC     HL              ; NEXT CHAR LEFT
            LD      (HL),A
            RET
;
; ********** TFCTRL **********
;
;           Traffic control routine
;
TFCTRL      LD      HL,GENFLG       ; CHECK REGENERATION FLAG
            XOR     A
            CP      (HL)
            JR      Z,GENER         ; IF ZERO, TEST GENERATE
            DEC     (HL)            ; DECR GENERATION FLAG
            RET
GENER       LD      HL,OB1EXT       ; START OF TRAFFIC DB
            LD      DE,12           ; 12 BYTE DATABASE
            LD      B,6             ; 6 DB PAIRS
TCTRLP      CP      (HL)            ; TEST EXISTENCE
            JR      NZ,NSPACE
            CALL    REGEN           ; REGENERATION ROUTINE
            RET
NSPACE      ADD     HL,DE
            DJNZ    TCTRLP
            RET
;
;
; ********** REGEN **********
;   Página 205
;           regeneration of TRAFFIC
;           INPUT: HL=>DB PAIRS
;
REGEN       PUSH    HL
RAND1       CALL    RANDNO          ; RANDOM NUMBER ROUTINNE
            AND     7               ; GENERATE RANDOM NUMBER
            CP      6               ; FROM 0 TO 5
            JR      NC,RAND1
            LD      BC,$5921        ; TWO CHAR TEST
            LD      HL,$5920        ; TEST JAM
            BIT     0,A             ; ODD NUMBER IS LEFT
            JR      Z,RTRAF         ; RIGHT TRAFFIC
            LD      L,$DF
            LD      C,$DE
RTRAF       ADD     A,A             ; GET DBINDEX PTR IN DE
            LD      E,A
            LD      A,(BC)          ; TEST 2 CHAR AHEAD
            ADD     A,(HL)
            AND     A               ; ZERO PAPER, ZERO INK
            JR      Z,LOADDB        ; IF 0, INITIALISE NEW OBJ
            POP     HL              ; IF JAM, RETURN
            RET
LOADDB      LD      D,A             ; A=0
            LD      HL,DBINDEX      ; GET DB
            ADD     HL,DE
            LD      E,(HL)          ; GET CORR DATABASE
            INC     HL
            LD      D,(HL)
            EX      DE,HL           ; SOURCE
            POP     DE              ; DESTINATION
            LD      BC,12
            LDIR
            LD      A,2             ; SET REGENERATION FLAG
            LD      (GENFLG),A      ; SKIP FOR 2 CYCLES
            RET
;
;
; ********** MOVTRF **********
;
;           MOVE TRAFFIC ROUTINE
;
MOVTRF      EXX
            LD      HL,OB1EXT
            LD      DE,12
            LD      B,6
MTRFLP      PUSH    HL
            EXX
            POP     HL              ; EXISTENCE
            LD      A,(HL)          ; SKIP WHEN NO EXIST
            AND     A
            JP      Z,NXTMOV
            INC     HL              ; CYCLE COUNT
            DEC     (HL)            ; DECR CYCLE COUNT
            JP      NZ,NXTMOV
            INC     HL              ; DIRECTION
;   Página 206
            LD      A,(HL)          ; 0 L TO R, 1 R TO L
            INC     HL
            INC     HL
            LD      (POSPTR),HL     ; POS PTR
            LD      E,(HL)          ; RESTORE POS
            INC     HL
            LD      D,(HL)
            INC     E               ; MOVE RIGHT
            AND     A
            JR      Z,LDPOS
            DEC     E               ; MOVE LEFT
            DEC     E               ; MOVE LEFT
LDPOS       LD      (NEWPOS),DE
            EX      AF,AF'
            LD      BC,5            ; RESTORE OBBJ LENGHT
            ADD     HL,BC
            LD      A,(HL)          ; ROW
            LD      (ROW),A
            INC     HL
            LD      A,(HL)          ; COLUMN
            LD      (COLUMN),A
            DEC     A
            LD      C,A
            EX      AF,AF'
            AND     A               ; TEST DIRECTION
            EX      DE,HL
            JR      NZ,RTOL         ; RIGHT TO LEFT
            ADD     HL,BC           ; FIND HEAD OF TRUCK
            LD      A,L             ; LOB
            CP      $40             ; TEST RIGHT EDGE
            JR      NC,MOVEOK       ; SKIP TEST AHEAD IF OFF
            JR      TESTAH          ; TEST AHEAD
RTOL        LD      A,L             ; NEW POS, AHEAD AS WELL
            CP      $C0             ; TEST LEFT EDGE
            JR      C,MOVEOK        ; SKIP TEST AHEAD
TESTAH      LD      A,H             ; CONVERT TO ATTR
            AND     $18
            SRA     A
            SRA     A
            SRA     A
            ADD     A,$58
            LD      H,A
            LD      BC,32
            XOR     A
            LD      (JAMFLG),A      ; INNITIALISE JAM FLAG
            LD      A,(ROW)
TAHLOP      EX      AF,AF'
            LD      A,(HL)          ; RETRIEVE ATTR
            AND     7
            JR      Z,TFROG1        ; JUMP IF BLACK INK
            CP      4               ; TEST FOR GREEN, FROG
            JR      NZ,JAM1         ; JAM IF NOT A FROG
            LD      A,1             ; MOVE IF IT IS FROG
            LD      (CRHFLG),A      ; SET FROG CRASH
            JR      TFROG1
JAM1        LD      (JAMFLG),A      ; SET JAMFLG NON ZERO
;   Página 207
TFROG1      AND     A
            SBC     HL,BC
            EX      AF,AF'
            DEC     A               ; UPDATE ROW
            JR      NZ,TAHLOP
            LD      A,(JAMFLG)      ; TEST TRAFFIC JAM
            AND     A
            JR      Z,MOVEOK        ; MOVE IF NO JAM
            EXX                     ; ELSE ESTOP MOVE ONE CYCLE
            INC     HL
            INC     (HL)            ; LOAD 2 TO CYCLE COUNT
            INC     (HL)
            DEC     HL
            EXX
            JR      NXTMOV
MOVEOK      LD      HL,(POSPTR)     ; RETRIEVE PTR TO POS
            LD      DE,(NEWPOS)
            LD      (HL),E          ; STORE NEWPOS IN DB
            INC     HL
            LD      (HL),D
            CALL    MVCTRL          ; MOVEMENT CONTROL
NXTMOV      EXX
            ADD     HL,DE
            DEC     B
            JP      NZ,MTRFLP
            EXX
            RET
;
; ********** MVCTRL **********
;
;           Traffic movement control routine
;
MVCTRL      DEC     HL
            DEC     HL              ; DE=>NEWPOS, HL=>DB PTR
            LD      A,E             ; LOB POS
            AND     $1F             ; TEST EDGE
            JR      NZ,CHGRAF       ; CHANGE REAL ABS FLAG
            LD      A,(HL)
            INC     A
            AND     1
            LD      (HL),A
CHGRAF      DEC     HL              ; PT DIR
            LD      A,(HL)
            AND     A
            JR      NZ,TOLEFT       ; RIGHT TO LEFT
            LD      A,E
            AND     $1F             ; IF TO RIGHT AND ABS
            JR      NZ,DRWOBJ
            INC     HL              ; GET RAF
            LD      A,(HL)
            DEC     HL              ; PT TO DIR
            AND     A               ; IF ABSTRACT, DIES
            JR      NZ,DRWOBJ
            EXX
            LD      (HL),A          ; SET NON EXISTENCE
            EXX
;   Página 208
            RET
TOLEFT      LD      A,(COLUMN)
            LD      C,A
            EX      DE,HL           ; TEST END OF OBJECT
            ADD     HL,BC           ; TOUCHES LEFT EDGE
            LD      A,L
            CP      $C0
            EX      DE,HL
            JR      NZ,DRWOBJ
            EXX                     ; OBJECT NONEXIST AS
            LD      (HL),0          ; IT MOVES OFF SCREEN
            EXX
            RET
DRWOBJ      EXX
            LD      A,(HL)
            INC     HL
            LD      (HL),A          ; REFILL CYCLE COUNT
            DEC     HL
            EXX
            INC     HL
            PUSH    HL              ; PT TO RAF
            INC     HL
            INC     HL
            INC     HL
            LD      E,(HL)          ; RETRIEVVE SHAPE PTR
            INC     HL
            LD      D,(HL)
            INC     HL
            LD      C,(HL)          ; RETRIVE ATTR PTR
            INC     HL
            LD      B,(HL)
            LD      (ATTPTR),BC
            INC     HL
            LD      A,(HL)
            LD      (ROW),A
            INC     HL
            LD      A,(HL)
            LD      (COLUMN),A
            POP     HL
            LD      A,(HL)          ; RAFLAG
            LD      HL,(NEWPOS)
            CALL    DRAW
            RET
;
;
;
; ********** DRAW   **********
;
;           INPUT:  HL=>START IF DISPLAY POS
;                   DE=>PTR TO SHAPE DB
;                   A =>POSITION REAL/ABSTRACT FLAG
;                   C =>NO. OF COL TO BE DISPLAY
;                   COL PASS AS VAR
;
;           VAR     COLUMN, ROW, ATTR, DRWPOS
;                   SKIP, FILL
;   Página 209
;
;           REG:    A,BC,DE,HL,A'
;
DRAW        CALL    RSHAPE          ; RETURN ROW/COL ATTPTR
            LD      A,(ROW)
            EX      AF,AF'
LP0         PUSH    DE
            PUSH    HL              ; STORE LINE PTR
            LD      A,(SKIP)
            LD      C,A
            LD      B,0
            ADD     HL,BC           ; SKIP POS PTR
            ADD     A,A             ; MULTIPLE OF 8 BYTES
            ADD     A,A
            ADD     A,A
            LD      C,A             ; SKIP SHAPE PTR
            EX      DE,HL
            ADD     HL,BC
            EX      DE,HL
            BIT     0,H             ; CROSS SCREEN SECTION?
            JR      Z,NOSKIP
            LD      A,7             ; IF YES, MOVE UP
            ADD     A,H
            LD      H,A
NOSKIP      LD      A,(FILL)
            AND     A
            JR      Z,NXT
            LD      C,A             ; COLUMN TO BE FILLED
LP1         PUSH    HL              ; FILL CHARACTER
            LD      B,8
LP2         LD      A,(DE)          ; FILL CHARACTER BYTES
            LD      (HL),A
            INC     DE
            INC     H
            DJNZ    LP2
            POP     HL
            DEC     C
            JR      Z,NXT
            INC     HL              ; NEXT CHARACTER
            JR      LP1
NXT         EX      AF,AF'
            POP     HL              ; RESTORE LINE PTR
            POP     DE              ; SHAPE DB PTR
            DEC     A               ; UPDATE ROW COUNT
            JR      Z,LDATTR
            EX      AF,AF'
            AND     A               ; CLEAR CARRY
            LD      C,$20
            SBC     HL,BC           ; ONE LINNE UP
            BIT     0,H             ; CROSS SCREEN SECTION?
            JR      Z,MODDB
            LD      A,H
            SUB     7
            LD      H,A
MODDB       LD      A,(COLUMN)
;   Página 210
            ADD     A,A
            ADD     A,A
            ADD     A,A             ; UPDATE SHAPE DB
            LD      C,A
            EX      DE,HL
            ADD     HL,BC
            EX      DE,HL
            JR      LP0
LDATTR      LD      HL,(ATTPOS)
            LD      DE,(ATTPTR)
            LD      A,(ROW)
ATROW       EX      AF,AF'
            PUSH    DE
            PUSH    HL
            LD      A,(SKIP)
            LD      C,A
            LD      B,0
            ADD     HL,BC           ; SKIP ATTRIBUTE FILE
            EX      DE,HL
            ADD     HL,BC           ; SKIP ATTRIBUTE DATABASE
            EX      DE,HL
            LD      A,(FILL)
            AND     A
            JR      Z,SKIPAT        ; SKIP ATTRIBUTE
            LD      B,A             ; FILL ATTRIBUTES
ATTR2       LD      A,(DE)
            LD      (HL),A
            INC     HL
            INC     DE
            DJNZ    ATTR2
SKIPAT      POP     HL
            POP     DE
            LD      A,(COLUMN)
            AND     A               ; CLEAR CARRY
            LD      C,$20
            SBC     HL,BC           ; NEXT ATTRIBUTE LINE UP
            LD      C,A
            EX      DE,HL
            ADD     HL,BC           ; UPDATE ATTRIBUTE DB
            EX      DE,HL
            EX      AF,AF'
            DEC     A
            JR      NZ,ATROW
            RET
;
;
; ********** RSHAPE **********
;
;           INPUT:  HL=>POSITION
;                   A =>REAL/ABSTRACT FLAG
;                   DE=>SHAPE PTR
;                   COLUMN
;
;           OUTPUT: SKIP, FILL, ATTPOS
;
RSHAPE      PUSH    HL
;   Página 211
            EX      AF,AF'          ; REAL SHAPE
            LD      H,$1F
            LD      A,H
            AND     L               ; TRAP LOWER 5 BITS
            LD      L,A
            LD      A,H
            SUB     L               ; SUBTRACT FROM $1F
            INC     A
            AND     H               ; ADJUST FOR ZERO DIFF
            LD      L,A
            EX      AF,AF'
            AND     A               ; 0=>ABSTRACT, 1=>REAL
            LD      A,(COLUMN)
            JR      NZ,REAL
            SUB     L
            LD      (FILL),A
            LD      A,L             ; RELOAD ABS DIFF
            LD      (SKIP),A
            JR      CALATT
REAL        CP      L               ; TAKE MIN OF COL/FILL
            JR      C,TOOBIG        ; FILL MORE THAN COL
            LD      A,L
            AND     A
            JR      NZ,TOOBIG
            LD      A,(COLUMN)
TOOBIG      LD      (FILL),A
            XOR     A
            LD      (SKIP),A
CALATT      POP     HL              ; CALCULATE ATT PTR
            PUSH    HL
            LD      A,H
            AND     $18
            SRA     A
            SRA     A
            SRA     A
            ADD     A,$58
            LD      H,A
            LD      (ATTPOS),HL
            POP     HL
            RET
;
;
CLRSCR      LD      HL,$4000        ; HL=>START OF SCREEN
            LD      DE,$4001
            LD      BC,6143         ; SIZE OF SCREEN $17FF
            XOR     A               ; BLANK SCREEN
            LD      (HL),A
            LDIR
            LD      HL,$5800        ; SET FIRST LINE FOR SCORE
            LD      DE,$5801        ; OF ATTRIIBUTE FILE
            LD      BC,31
            LD      (HL),7          ; INK SEVEN
            LDIR
            LD      HL,$5820        ; SET ATTRIBUTE
            LD      DE,$5821        ; START FROM SECOND LINE
            LD      BC,735
;   Página 212
            LD      (HL),A          ; (PAPER 0)*8+(INK 0)
            LDIR
            LD      HL,$58A0        ; SET HIGHWAY
            LD      DE,$5960        ; HIGH, MIDDLE, BOTTOM
            LD      BC,$5A20
            LD      A,56            ; (PAPER 7)*8+(INK 0)
            EXX
            LD      B,32            ; FILL ONE LINE
HWYATT      EXX
            LD      (HL),A
            LD      (DE),A
            LD      (BC),A
            INC     HL
            INC     DE
            INC     BC
            EXX
            DJNZ    HWYATT
            EXX
            RET
;
;
SHAPE       PUSH    HL              ; SAVE HL PTR
            LD      A,(FRGDIR)
            ADD     A,A
            LD      HL,FRGSHP
            LD      D,0
            LD      E,A
            ADD     HL,DE           ; PTR TO POS OF SHAPE
            LD      E,(HL)          ; DE RETURN SHAPE PTR
            INC     HL
            LD      D,(HL)
            POP     HL
            RET
;
;
; ********** DISASC **********
;
;           display ASCII value from character set
;           NB:---- store DE, the message pointer
;                   HL stays the same after display
;                   used BC register as well
;
;
DISASC      PUSH    BC
            PUSH    DE
            PUSH    HL
            LD      A,(DE)          ; LOAD ASCII CHAR
            LD      L,A
            LD      H,0
            ADD     HL,HL           ; MULTIPLE OF 8 BYTES
            ADD     HL,HL
            ADD     HL,HL
            EX      DE,HL
            LD      HL,CHRSET       ; START OF CHARACTER SET
            ADD     HL,DE
            EX      DE,HL
;   Página 213            
            POP     HL
DRWCHR      LD      B,8             ; DRAW CHARACTER
            PUSH    HL
CHARLP      LD      A,(DE)
            LD      (HL),A
            INC     DE
            INC     H
            DJNZ    CHARLP
            POP     HL
            POP     DE
            INC     HL              ; POS PTR
            INC     DE              ; MESSAGE PTR
            POP     BC
            DJNZ    DISASC
            RET
;
;
POLICE      EXX
            LD      HL,PCAREXT
            LD      A,(HL)          ; TEST POLICE CAR EXIST
            PUSH    HL
            EXX
            AND     A
            JR      NZ,MOVPC        ; MOVE POLICE CAR
            POP     DE              ; DB EXT PTR
            CALL    RANDNO          ; MOVE WHEN MULTIPLE OF
            AND     $1F             ; 31
            CP      $1F
            RET     NZ
            LD      A,1             ; SET CHASE FLAG
            LD      (CHASE),A
            LD      HL,RPCDB        ; RIGHT PC
            CALL    RANDNO
            AND     1
            JR      Z,RHTPC
            LD      HL,LPCDB
RHTPC       LD      BC,12
            LDIR
            EXX
            PUSH    HL
            EXX
MOVPC       POP     HL              ; EXISTENCE PTR
            INC     HL
            INC     HL              ; DIRECTION
            LD      A,(HL)
            LD      B,A             ; STORE DIR
            INC     HL
            INC     HL              ; POSPTR
            LD      (POSPTR),HL
            LD      E,(HL)
            INC     HL
            LD      D,(HL)
            INC     E               ; ASSUME MOVE RIGHT
            AND     A
            JR      Z,PCMRHT        ; POLICE MOVE CAR RIGHT
            DEC     E
;   Página 214            
            DEC     E
PCMRHT      LD      (NEWPOS),DE
            LD      A,2             ; TWO ROW
            LD      (ROW),A
            LD      A,6
            LD      (COLUMN),A
            PUSH    BC              ; DIRECTION
            LD      A,(PCARRAP)     ; REAL/ABS FLAG
            EX      DE,HL
            CALL    RSHAPE          ; RET SKIP/FILL, ATTR
            LD      HL,(ATTPOS)
            POP     AF
            AND     A               ; IF 1, OK
            JR      NZ,PCTAH        ; POLICE CAR TEST AHEAD
            LD      BC,5
            ADD     HL,BC
PCTAH       LD      A,(HL)
            AND     7
            LD      BC,32
            AND     A
            SBC     HL,BC
            CP      4
            JR      Z,ISFRG2
            LD      A,(HL)
            AND     7
            CP      4
            JR      NZ,NFROG2
ISFRG2      LD      A,1
            LD      (CRHFLG),A      ; SET CRASH FLAG
            DEC     A               ; BLANK COLOUR
            LD      (HL),A          ; BLANK FRONT OF PC
            ADD     HL,BC
            LD      (HL),A          ; ** SHOULD BLANK FRONT*
NFROG2      CALL    STRPC           ; STORE NEW UNDERNEATH
            LD      HL,(POSPTR)
            LD      DE,(NEWPOS)
            LD      (HL),E
            INC     HL
            LD      (HL),D
            CALL    MVCTRL
            EXX                     ; IF NON-EXIST
            LD      A,(HL)
            LD      (CHASE),A
            EXX
            RET
;
;
; ********** STRPC **********
;
;           STORE UNNDERNEATH POLICE CAR
;
STRPC       LD      HL,(NEWPOS)     ; POS PTR
            LD      DE,PCSTR        ; STORAGE LOC
            EX      DE,HL
            LD      (HL),E          ; STORE POSITON
            INC     HL
;   Página 215            
            LD      (HL),D
            INC     HL
            EX      DE,HL
            LD      HL,ROW          ; LOAD 5 BYTES OF INFO
            LD      A,(HL)
            LD      BC,5
            LDIR
            EX      AF,AF'
            LD      HL,(NEWPOS)
SPCLP1      PUSH    HL
            LD      A,(SKIP)
            LD      C,A
            ADD     HL,BC
            BIT     0,H
            JR      Z,NSSPS
            LD      A,H
            ADD     A,7
            LD      H,A
NSSPS       LD      A,(FILL)
            AND     A
            JR      Z,NXTSPC
            LD      C,A
SPCLP2      PUSH    HL              ; RESTORE DATA
            LD      B,8
SPCLP3      LD      A,(HL)          ; STORE SCREEN FIRST
            LD      (DE),A
            INC     DE
            INC     H
            DJNZ    SPCLP3
            POP     HL
            INC     HL              ; NEXT CHAR
            DEC     C
            JR      NZ,SPCLP2
NXTSPC      POP     HL
            EX      AF,AF'          ; UPD ROW COUNT
            DEC     A
            JR      Z,SPCATR        ; RESTORE POLICE ATTR
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC           ; UP ONLE LINE
            BIT     0,H             ; CROSS SCREEN SECTION?
            JR      Z,SPCLP1
            LD      A,H
            SUB     7
            LD      H,A
            JR      SPCLP1
SPCATR      LD      HL,(ATTPOS)     ; ATTRIBUTE START POS
            LD      A,(ROW)
            EX      AF,AF'
SPCAT1      PUSH    HL
            LD      A,(SKIP)
            LD      C,A
            ADD     HL,BC
            LD      A,(FILL)
            AND     A
            JR      Z,NXTSPA
;   Página 216            
            LD      C,A
            LDIR
NXTSPA      POP     HL
            EX      AF,AF'
            DEC     A
            RET     Z
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC
            JR      SPCAT1
;
;
RESPC       LD      A,(PCAREXT)     ; TEST PC EXIST
            AND     A
            RET     Z
            LD      DE,ROW
            LD      HL,PCSTR+2
            LD      BC,5
            LDIR                    ; RETRIEVE 5 INFO
            EX      DE,HL           ; DE STORAGE PTR
            LD      HL,(PCSTR)      ; LOAD POS
            LD      A,(ROW)
            EX      AF,AF'
RPCLP1      PUSH    HL              ; SAVE POS
            LD      A,(SKIP)
            LD      C,A
            ADD     HL,BC
            BIT     0,H
            JR      Z,NSRPS
            LD      A,7
            ADD     A,H
            LD      H,A
NSRPS       LD      A,(FILL)
            AND     A
            JR      Z,NXTRPC
            LD      C,A
RPCLP2      PUSH    HL
            LD      B,8
RPCLP3      LD      A,(DE)          ; RESTORE CHAR
            LD      (HL),A
            INC     DE
            INC     H
            DJNZ    RPCLP3
            POP     HL
            INC     HL
            DEC     C
            JR      NZ,RPCLP2
NXTRPC      POP     HL
            EX      AF,AF'
            DEC     A               ; UPD ROW COUNT
            JR      Z,RPCATR        ; RESTORE POLICE CAR
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC           ; MOVE UP ONE LINNE
            BIT     0,H
            JR      Z, RPCLP1
;   Página 217
            LD      A,H
            SUB     7               ; CROSSS BOUNDARY
            LD      H,A
            JR      RPCLP1
RPCATR      LD      HL,(ATTPOS)     ; ATTR START LOADING POS
            LD      A,(ROW)
            EX      AF,AF'
RPCAT1      PUSH    HL
            LD      A,(SKIP)
            LD      C,A
            ADD     HL,BC
            LD      A,(FILL)
            AND     A
            JR      Z,NXTRPA
            EX      DE,HL
            LD      C,A
            LDIR
            EX      DE,HL
NXTRPA      POP     HL
            EX      AF,AF'
            DEC     A
            RET     Z
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC
            JR      RPCAT1
;
;
FROG        LD      A,(CRHFLG)      ; CRASH FLAG
            AND     A
            JR      NZ,FRGCRH       ; FROG CRASH
            LD      (UPDWN),A       ; SET NO SCORE
            CALL    REGFRG          ; REGENERATE FROG
            LD      HL,FRGCYC       ; TEST MOVE
            DEC     (HL)
            RET     NZ
            DEC     HL
            LD      A,(HL)          ; RESET CYCLE COUNT
            INC     HL
            LD      (HL),A
            CALL    MOVFRG
            LD      A,(CRHFLG)
            AND     A
            RET     Z
FRGCRH      CALL    CRASH
            RET
;
; ********** REGFRG **********
;
;           Regenerate frog if any left
;           Set GAMFLG to 0 if none left
;
REGFRG      LD      A,(FRGEXT)
            AND     A
            RET     NZ              ; RETURN IF EXIST
            LD      HL,FRGDB
;   Página 218            
            LD      DE,FRGEXT
            LD      BC,8
            LDIR
            LD      HL,FRGSTN       ; UPDATE FROG STATION
            DEC     (HL)            ; MOVE 3 CHARACTER LEFT
            DEC     (HL)
            DEC     (HL)
            LD      HL,(FRGPOS)
            LD      (OLDFRG),HL
            LD      (NEWFRG),HL
            LD      HL,FRGSTR       ; INIT FRG STR FOR RES
            LD      DE,FRGSTR+1     ; BLANK FROG STORE
            LD      BC,35
            LD      (HL),0
            LDIR
            RET
;
; ********** MOVFRG **********
;
;           Move frog, store and restore
;
MOVFRG      XOR     A
            LD      HL,$E020        ; H=-32, L=32
            LD      C,A             ; C=>ABS MOVEMENT
            EX      AF,AF'
            LD      A,$DF           ; TEST RIGHT
            IN      A,($FE)
            AND     1               ; TEST KEY P
            JR      NZ,LEFT
            INC     C
            LD      DE,FROG2
            LD      B,1
LEFT        LD      A,$DF           ; TEST LEFT
            IN      A,($FE)
            AND     2               ; TEST KEY O
;            AND     4               ; ORIGINAL TEST KEY I
            JR      NZ,DOWN
            DEC     C
            LD      DE,FROG4
            LD      B,3
DOWN        LD      A,$FD           ; TEST DOWN
            IN      A,($FE)
            AND     1               ; TEST KEY A
            JR      NZ,UP
            LD      A,C
            ADD     A,L             ; ADD 32
            LD      C,A
            EX      AF,AF'
            DEC     A
            EX      AF,AF'          ; DEC UP/DWN FLG
            LD      DE,FROG3
            LD      B,2
UP          LD      A,$FB           ; TEST UP
;            LD      A,$F7           ; ORIGINAL TEST KEY 1
            IN      A,($FE)
            AND     1               ; TEST KEY Q
            JR      NZ,VALID
            LD      A,C
;   Página 219            
            ADD     A,H             ; ADD -32
            LD      C,A
            EX      AF,AF'
            INC     A
            EX      AF,AF'
            LD      DE,FROG1
            LD      B,0
VALID       LD      A,B             ; STORE TEMP DIR
            LD      (TEMDIR),A
            LD      (TEMSHP),DE    ; STORE SHAPE
            XOR     A
            CP      C
            RET     Z               ; IF NO MOVE GO BACK
            LD      HL,(OLDFRG)
            BIT     7,C             ; TEST -VE
            LD      B,A
            LD      E,7             ; FOR BOUNDARY ADJ
            JR      Z,NETDWN        ; NET MOVE RHT,DWN
            DEC     B
            LD      E,-7
NETDWN      ADD     HL,BC
            BIT     0,H
            JR      Z,VALID1        ; NO CROSS BOUNDARY
            LD      A,H
            ADD     A,E
            LD      H,A             ; ADJ HOB
VALID1      LD      (TEMPOS),HL
            EX      DE,HL
            LD      A,$40           ; TEST UPSCR
            CP      D
            LD      A,E
            JR      NZ,VALID2
            CP      $20
            JR      C,NVALID
VALID2      AND     $1F             ; TEST RIGHT BOUNDARY
            CP      $1F
            JR      Z,NVALID
            LD      HL,$50BE        ; TEST BOT BOUNDARY
            AND     A
            SBC     HL,DE
            JR      C,NVALID
            LD      HL,$507E        ; TEST FROG STATION
            SBC     HL,DE
            JR      NC,YVALID
            LD      A,E             ; TEST WITHIN BOX
            AND     $1F
            LD      H,A
            LD      A,(FRGSTN)
            CP      $A0             ; TEST LAST FROG
            JR      C,YVALID        ; NO MORE FROG STATION
            INC     A               ; WHEN NO FROG LEFT
            AND     $1F
            SUB     H
            JR      NC,NVALID
YVALID      LD      (NEWFRG),DE     ; STORE NEW POS
            EX      AF,AF'
;   Página 220
            LD      (UPDWN),A
            EX      AF,AF'
NVALID      LD      HL,(OLDFRG)     ; TEST OLDFRG=NEWFRG
            AND     A
            SBC     HL,DE
            LD      A,L
            OR      H
            RET     Z               ; RETURN IF SAME
            CALL    RESFRG          ; RESTORE FROG
            LD      HL,(NEWFRG)     ; UPDATE OLD FROG POS
            LD      (OLDFRG),HL
            LD      HL,TEMDIR
            LD      DE,FRGDIR
            LD      BC,5
            LDIR
            CALL    STRFRG
            RET
;
;
RESFRG      LD      DE,FRGSTR       ; STORAGE PTR
            LD      HL,(OLDFRG)     ; RETORE FROM OLDPOS
            PUSH    HL
            LD      A,2             ; ROW COUNTER
            EX      AF,AF'
RFRLP1      PUSH    HL
            LD      C,2             ; COLUMN COUNTER
RFRLP2      PUSH    HL
            LD      B,8
RFRLP3      LD      A,(DE)          ; RESTORE FROM DB
            LD      (HL),A          ; ONTO SCREEN
            INC     DE
            INC     H               ; NEXT CHAR BYTE            
            DJNZ    RFRLP3
            POP     HL
            INC     HL
            DEC     C               ; COLUMN COUNT
            JR      NZ,RFRLP2
            POP     HL
            EX      AF,AF'
            DEC     A               ; ROW COUNT
            JR      Z,RFRATR
            EX      AF,AF'
            AND     A
            LD      C,32            ; UP ONE LINE
            SBC     HL,BC
            BIT     0,H
            JR      Z,RFRLP1
            LD      A,H
            SUB     7
            LD      H,A
            JR      RFRLP1
RFRATR      POP     HL
            LD      A,H
            AND     $18
            SRA     A
            SRA     A
;   Página 221
            SRA     A
            ADD     A,$58
            LD      H,A
            LD      A,2             ; ROW COUNTER
            EX      AF,AF'
RFRAT1      PUSH    HL
            EX      DE,HL
            LD      C,2             ; RESTORE ATTR
            LDIR
            EX      DE,HL
            POP     HL
            EX      AF,AF'
            DEC     A               ; UPDATE ROW COUNTER
            RET     Z
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC
            JR      RFRAT1
;
;
STRFRG      LD      DE,FRGSTR
            LD      HL,(NEWFRG)     ; STORE BASE ON NEWPOS
            EXX
            LD      HL,(FROGSH)     ; LOAD  SHAPE AS WELL
            EXX
            PUSH    HL
            LD      A,2
            EX      AF,AF'
SFRLP1      PUSH    HL
            LD      C,2
SFRLP2      PUSH    HL
            LD      B,8             ; STORE AND LOAD A CHAR
SFRLP3      LD      A,(HL)
            LD      (DE),A
            EXX
            LD      A,(HL)
            INC     HL
            EXX
            LD      (HL),A
            INC     DE
            INC     H
            DJNZ    SFRLP3
            POP     HL
            INC     HL              ; NEXT CHAR
            DEC     C
            JR      NZ,SFRLP2
            POP     HL
            EX      AF,AF'
            DEC     A
            JR      Z,SFRATR
            EX      AF,AF'
            AND     A
            LD      C,32
            SBC     HL,BC           ; NEXT ROW
            BIT     0,H
            JR      Z,SFRLP1
;   Página 222
            LD      A,H
            SUB     7
            LD      H,A
            JR      SFRLP1
SFRATR      POP     HL
            LD      A,H             ; CALCULATE ATTR POS
            AND     $18
            SRA     A
            SRA     A
            SRA     A
            ADD     A, $58
            LD      H,A
            LD      A,2
            EX      AF,AF'
SFRAT1      LD      B,2
            PUSH    HL
SFRATLP     LD      A,(HL)
            LD      (DE),A
            LD      (HL),4          ; FILL FROG ATTR
            INC     HL
            INC     DE
            AND     7               ; TEST CRASH
            JR      Z,NFROG3
            LD      A,1
            LD      (CRHFLG),A
NFROG3      DJNZ    SFRATLP
            POP     HL
            EX      AF,AF'
            DEC     A
            RET     Z
            EX      AF,AF'
            LD      C,32
            SBC     HL,BC
            JR      SFRAT1
;
;
CRASH       XOR     A
            LD      (CRHFLG),A      ; RESET CRASH FLAG
            LD      (FRGEXT),A      ; SET FROG NONEXIST
            CALL    FRGDIE          ; FROG DYING ROUTINE
            CALL    RESFRG
            LD      HL,NUMFRG
            DEC     (HL)            ; DECREASE FROG NUMBER
            RET     NZ
            LD      (GAMFLG),A      ; ZEROISE GAME FLAG
            RET                     ; WHEN NO FROG LEFT
;
;
FRGDIE      LD      HL,(OLDFRG)     ; OLD POS OF FRG
            LD      BC,$4002        ; RED COLOUR
            EXX
            LD      HL,DIETON       ; SET DIE TON
            EXX
            LD      A,H             ; TEST END OF JOURNEY
            CP      B
            JR      NZ,NOTEND
;   Página 223
            LD      A,L
            CP      B
            JR      NC,NOTEND
            LD      DE,SCORE+3      ; 100 PTS BONUS
            EX      DE,HL
            INC     (HL)
            LD      HL,SCORE+4
            CALL    DISSCR
            LD      C,6             ; YELLOW
            EXX
            LD      HL,HOMTON
            EXX
NOTEND      LD      A,C
            LD      (ATTR),A
            LD      HL,(OLDFRG)
            LD      DE,(FROGSH)
            CALL    DRWFRG
            LD      DE,32           ; LINE ADJUST
            ADD     HL,DE
            EX      AF,AF'
            LD      A,(ATTR)
            EX      AF,AF'
            LD      B,5
FLASLP      PUSH    BC
            PUSH    HL              ; ATTRIBUTE PTR
            XOR     A               ; BLACK INK BLACK PAPER
            LD      (HL),A
            INC     HL
            LD      (HL),A
            SBC     HL,DE
            LD      (HL),A
            DEC     HL
            LD      (HL),A
            CALL    FRGTON          ; GENERATE FROG TONE
            POP     HL
            PUSH    HL
            EX      AF,AF'
            LD      (HL),A          ; BLACK PAPER, RED OR
            INC     HL              ; YELLOW INK
            LD      (HL),A
            AND     A
            SBC     HL,DE
            LD      (HL),A
            DEC     HL
            LD      (HL),A
            EX      AF,AF'
            CALL    FRGTON
            POP     HL
            POP     BC
            DJNZ    FLASLP
            RET
;
;
FRGTON      EXX
            PUSH    HL
            CALL    TONE1
;   Página 224            
            POP     HL
            LD      BC,4            ; MOVE DOWN DATABASE
            EX      AF,AF'
            CP      6
            JR      Z,HOME
            LD      BC,-4           ; MOVE UP DATABASE
HOME        ADD     HL,BC
            EXX
            EX      AF,AF'
            RET
;
;
CALSCR      LD      A,(FRGEXT)      ; TEST EXISTENCE
            AND     A
            RET     Z               ; NO UPDATE OF SCORE
            LD      A,(UPDWN)       ; TEST UP/DOWN MOVEMENT
            AND     A               ; TEST ANY SCORE
            RET     Z
            LD      HL,SCORE+4      ; ADD 10 TO SCORE
            BIT     7,A             ; TEST MOVE DOWN
            JR      NZ,DWNSCR       ; DOWN SCORE
            INC     (HL)
            JR      DISSCR          ; DIS SCORE
DWNSCR      LD      A,(OLDFRG+1)    ; TEST HOB
            CP      $40             ; TEST FIRST BLOCK
            JR      NZ,TLHWY        ; TEST LOW HIGHWAY
            LD      A,(OLDFRG)
            CP      $C0             ; NOT EVEN STEP ON HWY
            RET     C
            INC     (HL)
            JR      DISSCR
TLHWY       CP      $50             ; TEST IN LOW HWY
            RET     NZ
            LD      A,(OLDFRG)
            CP      $20
            RET     NC              ; NO SCORE IF STEP HWY
            INC     (HL)
DISSCR      LD      B,4             ; HL=>TENTH'S POS
ADDLOP      LD      A,(HL)
CRYLOP      CP      $3A             ; CARRY LOOP
            JR      C,UPDDIG        ; UPDATE DIGIT
            SUB     10
            DEC     HL
            INC     (HL)            ; CARRY
            INC     HL
            JR      CRYLOP
UPDDIG      LD      (HL),A
            DEC     HL
            DJNZ    ADDLOP
            LD      HL,SCORE+1
            CALL    SCRIMG          ; SCORE IMAGE
            LD      HL,$4006
            LD      DE,IMAGE
            LD      B,5
            CALL    DISASC
            RET
;   Página 225
;
SCRIMG      LD      DE,IMAGE
            LD      BC,5
            LDIR
            LD      HL,IMAGE
            LD      BC,$0430
PREZER      LD      A,C
            CP      (HL)            ; TEST $30
            JR      NZ,PREZEX
            LD      (HL),$20        ; SPACE FILL
            INC     HL
            DJNZ    PREZER
PREZEX      RET
;
;
SIREN       LD      A,$BF
            IN      A,($FE)
            AND     1               ; TEST KEY ENTER
            JR      NZ,NSOUND
            LD      A,(SOUNDF)      ; RESET SOUND CONDITION
            INC     A
            AND     1
            LD      (SOUNDF),A
NSOUND      LD      A,(SOUNDF)
            AND     A
            JR      Z,DELAY
            LD      A,(CHASE)       ; IS POLICE CAR ON
            AND     A
            JR      Z,DELAY
            LD      A,(TONFLG)
            INC     A
            AND     1
            LD      (TONFLG),A
            LD      HL,PCTON1
            JR      Z,TONE1
            LD      HL,PCTON2
TONE1       LD      E,(HL)          ; DE=DURATION*FREQUENCY
            INC     HL
            LD      D,(HL)
            INC     HL
            LD      C,(HL)
            INC     HL
            LD      B,(HL)
            PUSH    BC
            POP     HL              ; HL=437500/FREQ-30.125
            CALL    $03B5
            DI                      ; $03B5 ENABLE INTERRUPT
            RET
DELAY       LD      BC,6144
WAIT        DEC     BC
            LD      A,B
            OR      C
            JR      NZ,WAIT
            RET
;
;   Página 226
RANDNO      PUSH    HL
            PUSH    BC
            LD      HL,(RND)
            LD      B,(HL)
            INC     HL
            LD      A,$3F           ; BOUND POINTER WITHIN ROM
            AND     H
            LD      H,A
            LD      A,B
            LD      (RND),HL
            POP     BC
            POP     HL
            RET
;
;
OVER        LD      HL,SCORE+1      ; HIGH SCORE MANAGE
            LD      DE,HISCR
            LD      B,5
SORTLP      LD      A,(DE)
            CP      (HL)
            JR      Z,SAMSCR        ; TEST 1ST NE DIGIT
            RET     NC
            JR      SCRGT           ; UPDATE HIGH SCORE
SAMSCR      INC     DE
            INC     HL
            DJNZ    SORTLP
            RET
SCRGT       LD      HL,SCORE+1
            LD      DE,HISCR
            LD      BC,5
            LDIR
            RET
;
;
; ********** FINAL **********
;
FINAL       LD      A,56            ; SET WHITE BORDER
            LD      (23624),A
            LD      HL,$4000        ; START OF SCREEN
            LD      DE,$4001
            LD      BC,6143         ; SIZE OF SCREEN
            LD      (HL),0
            LDIR
            LD      HL,$5800        ; START OF ATRIBUTE FILE
            LD      DE,$5801
            LD      BC,767
            LD      (HL),56         ; WHITE PAPER BLACK INK
            LDIR
            RET
;
;
            END     START